#!/bin/bash
experiment_yaml="exp1"
# num_cpus=${SLURM_CPUS_PER_TASK}
num_cpus=12
runs=("dataset=covcon")
# runs=("dataset=airlines" "dataset=covertype" "dataset=gauss" "dataset=circles" "dataset=covcon" "dataset=covcon dataset/queries=static_middle" "dataset=circles dataset/queries=static_middle" "dataset=gauss dataset/queries=static_middle")
#runs=("dataset=elec" "dataset=airlines" "dataset=covertype" "dataset=gauss" "dataset=circles" "dataset=covcon" "dataset=covcon dataset/queries=static_middle" "dataset=circles dataset/queries=static_middle" "dataset=gauss dataset/queries=static_middle")

model="HT"
# model_random_range="model.kwargs.random_state="range(5)""
model_random_range=''
results_base_dir="tmp"

for run in "${runs[@]}"; do
	# train models and store cost matrices
	python src/create_cost_matrices.py -m -cn ${experiment_yaml} ray.num_cpus=${num_cpus} ${run} ${model_random_range} model=${model} results_base_dir=${results_base_dir}
	# Find the maximum retraining cost to evaluate for
	python src/find_max_retraining_cost.py -cn ${experiment_yaml} ray.num_cpus=${num_cpus} ${run} model=${model} results_base_dir=${results_base_dir}
	# Find the running times of the model and the cost computation
	python src/get_running_times.py -cn ${experiment_yaml} ray.num_cpus=${num_cpus} ${run} model=${model} results_base_dir=${results_base_dir}
	# Perform the offline and online analysis
	python src/run_retrain_cost_analysis.py -m -cn ${experiment_yaml} ray.num_cpus=${num_cpus} ${run} ${model_random_range} model=${model} results_base_dir=${results_base_dir}
done
