import numpy as np
from skmultiflow.drift_detection.adwin import ADWIN
import ray
from time import perf_counter as time

name = "ADWIN"
def run(models,datas,queries,**kwargs):
    detector_time = 0
    start = time()
    detector = ADWIN(**kwargs)
    detector_time += (time() - start)
    _model = models[0]
    retrain = False
    _retrains = set()
    for t in range(len(datas)):
        data = datas[t]
        if isinstance(data,ray._raylet.ObjectRef):
                data = ray.get(data)
        _X = data["X_train"]
        _y = data["y_train"]
        if retrain:
            _model = models[t-1]
            retrain = False
        
        if isinstance(_model,ray._raylet.ObjectRef):
                _model = ray.get(_model)
        
        start = time()
        _yhat = _model.predict(_X)
        errors = (_yhat!=_y)

        for i,_e in enumerate(errors):
            detector.add_element(_e)
            # if any drift is detected in the current batch retrain
            if detector.detected_change():
                _retrains.add(t)
                retrain=True
        detector_time += (time() - start)

    _retrains = list(_retrains)
    result = {"retrains":_retrains,"num_retrains":len(_retrains),"parameters":{},"detector_time":detector_time}
    return result