import numpy as np
from skmultiflow.drift_detection.kswin import KSWIN
import ray

name = "KSWIN"
def run(models,datas,queries,**kwargs):

    _data = datas[0]
    if isinstance(_data,ray._raylet.ObjectRef):
        _data = ray.get(_data)    
    d = _data["X_train"].shape[1]
    if kwargs and "alpha" in kwargs:
        kwargs["alpha"] /= d
    else:
        kwargs["alpha"] = 0.05/(60*d)
    detectors = [KSWIN(**kwargs) for _ in range(d)]
    _retrains = set()
    retrain = False
    for t in range(len(datas)):
        data = datas[t]
        if isinstance(data,ray._raylet.ObjectRef):
                data = ray.get(data)
        _X = data["X_train"]
        # reset detectors
        if retrain:
            for detector in detectors:
                detector.reset()
            retrain = False
        for _x in _X:
            for _xi,detector in zip(_x,detectors):
                detector.add_element(_xi)
                # if any drift is detected in the current batch retrain
                if detector.detected_change():
                    _retrains.add(t)
                    retrain = True
    _retrains = list(_retrains)
    result = {"retrains":_retrains,"num_retrains":len(_retrains),"parameters":{}}
    return result