
from pathlib import Path

import numpy as np
import pandas as pd
from sklearn.datasets import load_svmlight_file

proj_root = Path(__file__).parent.parent.parent.resolve()
from utils import get_online_offline_data_dict

url = "https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/covtype.libsvm.binary.scale.bz2"

def get_data(data_dir:Path,T:int=100):
    dataset_dir = data_dir/"covertype"
    X,y = load_svmlight_file(str((dataset_dir/"raw"/"covtype.libsvm.binary.scale").resolve()))
    # Change labels from 1,2 to 0,1
    y-=1
    X = X.toarray()
    X_split = np.array_split(X,T)
    y_split = np.array_split(y,T)

    return X_split,y_split


def load_dicts(cfg):
    data_dir = proj_root/cfg.dataset.data.dir
    X_full, y_full = get_data(data_dir,cfg.dataset.num_batches)
    offline_datas, online_datas = get_online_offline_data_dict(
        X_full,
        y_full,
        offline_split=cfg.dataset.offline_split,
        use_ray=cfg.use_ray,
        queries_split = cfg.dataset.queries.queries_split
    )
    if cfg.dataset.queries.name == "data":
        return offline_datas, online_datas, offline_datas, online_datas
